C     PROGRAM main for optimization and linear block programs
      implicit integer *4 (i-n)
      implicit real *8 (a-h,o-z)
      real *4 rzs
      parameter (MaxKbl=30,MaxMbl=50,MaxNbl=50,MaxNs=250,Maxvar=5)
      parameter (Mdzs=360000,Mizs=150000,Mrzs=10,
     *           nwar=970000,niwar=150000,MaxMtx=10)
      parameter (MaxX=MaxNs+MaxKbl*MaxNbl,MaxY=MaxKbl*MaxMbl,
     *           MaxZ=MaxX+MaxY,MaxAx=MaxMtx*MaxNs)
      external fun
      dimension izs(Mizs),rzs(Mrzs),dzs(Mdzs),
     1          xl(MaxNs),xu(MaxNs),xin(MaxNs),xout(MaxX),
     2          Ax(MaxAx),bx(MaxMtx),tpin(2),ipin(8),rpin(8),
     3          ipout(18),rpout(18),war(nwar),iwar(niwar),
     4          BB(MaxY),CC(MaxX),Res(MaxY)
      character *12 tpin, txt *60
C==============================================================
      write (*,*)
      write (*,*) '***************************************'
      write (*,*) '*   Version 5.03, December 01, 1999   *'
      write (*,*) '***************************************'
      write (*,*)
C-----
      Zero=0.0D0
      Half=0.5D0
      One=1.0D0
      Two=2.0D0
      Ten=1.0D1
      Hund=1.0D2
      Thous=1.0D3
      dinfty=1.0D31
      Epsa=1.0D-7
      XbxBl=Hund
      YbxBl=Thous
C=====GLOBAL CONTROL PARAMETERS================================
C     (limm) max number of iterations
      ipin(1)=20000
C     (iprnt) screen messages and protocol file (for MSG)
      ipin(2)=-2
C     (io1) # of output channel for Solver
      ipin(3)=15
      io1=ipin(3)
C     (lwar) length of real working array war
      ipin(4)=nwar
C     (liwar) length of integer working array iwar
      ipin(5)=niwar
C     not used
      ipin(6)=0
      ipin(7)=0
      ipin(8)=0
C-----
C     (epsrel) last relative accuracy required
      rpin(1)=1.0D-7
C     (cfrelb) coefficient for shrinking bundle
      rpin(2)=Half
C     (tol) tolerance
      rpin(3)=1.0D-6
C     (epsd) squared root of the diaganal in Zero matrix
      rpin(4)=1.0D-5
      epsd=rpin(4)
C     (epsp) Zero for Powell
      rpin(5)=1.0D-9
C     (qlv) level
      rpin(6)=Half
C     not used
      rpin(7)=Zero
      rpin(8)=Zero
C-----without debugging (idebg=0) / debugging (idebg>0)
      idebg=0
C=====NAMES OF FILES===========================================
C     file for input data of the problem 
      tpin(1)='input.dat'
C     file for writing the protocol
      tpin(2)='out.res'
C=====OPEN OUTPUT FILES========================================
      open (io1,file=tpin(2),status='new',err=253)
      goto 254
  253 open (io1,file=tpin(2),status='old')
  254 continue
C=====INPUT OF DIMENSIONS======================================
      open (2,file=tpin(1),status='old')
      read (2,'(i10)') Ns
      Ms=0
      read (2,'(i10)') Kbl
      read (2,'(i10)') Nx
      read (2,'(i10)') Ny
C-----
      if (idebg.ne.0) then
         write (*,*)
         write (*,*) ' Ns =',Ns,' Kbl=',Kbl,' Nx =',Nx,
     *               ' Ny =',Ny,' idebg=',idebg
      endif
C-----
      Nz=Nx+Ny
      Nxx=Nx+1
      Nyy=Ny+1
      Nzz=Nxx+Nyy
C-----INPUT of vectors CC and BB-------------------------------
      read (2,'((6e10.2))') (BB(i),i=1,Ny)
      read (2,'((6e10.2))') (CC(i),i=1,Nx)
      if (idebg.ne.0) then
         write (io1,*)
         write (io1,*) ' BB= '
         write (io1,*) (BB(i),i=1,Ny)
         write (io1,*) ' CC= '
         write (io1,*) (CC(i),i=1,Nx)
      endif
C-----Input of xl, xu and xin----------------------------------
      read (2,'((6e10.2))') (xl(i),i=1,Nx)
      read (2,'((6e10.2))') (xu(i),i=1,Nx)
      read (2,'((6e10.2))') (xin(i),i=1,Nx)
      if (idebg.ne.0) then
         write (io1,*) ' xl= '
         write (io1,*) (xl(i),i=1,Nx)
         write (io1,*) ' xu= '
         write (io1,*) (xu(i),i=1,Nx)
         write (io1,*) ' xin= '
         write (io1,*) (xin(i),i=1,Nx)
      endif
C=====INITIAL PRINT===========================================
      write (io1,*) ' Ns=   ',Ns,' Kbl=  ',Kbl,
     *              ' Nx=   ',Nx,' Ny=   ',Ny
      write (io1,*) ' idebg=',idebg
C=====MEMORY DISTRIBUTION======================================
      it=0
C.....for izs
C--------------------------------------------------------------
C     Ms=0  ==> izs(1), Ns    ==> izs(2), Kbl ==> izs(3),
C     MbMax ==> izs(4), NbMax ==> izs(5), it  ==> izs(6),
C     kki   ==> izs(7), Nx    ==> izs(8), Ny  ==> izs(9),
C     izs(10) not used, izs(5:9) will be defined below
C--------------------------------------------------------------
      Ms=0
      izs(1)=Ms
      izs(2)=Ns
      izs(3)=Kbl
      do i=4,10
         izs(i)=0
      enddo
C--------------------------------------------------------------
C     lMn ==> izs(11), lMs ==> izs(12), lNs ==> izs(13)
C--------------------------------------------------------------
      ifree=20
      ifree0=ifree
C.....for rzs
C--------------------------------------------------------------
C     rzs(1:10) not used
C--------------------------------------------------------------
      nfree=10
      nfree0=nfree
C.....for dzs
C--------------------------------------------------------------
C     epsd=rpin(4) => dzs(1), dzs(2:10) not used
C--------------------------------------------------------------
      dzs(1)=epsd
      jfree=10
      jfree0=jfree
      ifree=ifree0
      jfree=jfree0
      nfree=nfree0
      ipout(1)=0
      ipout(2)=0
      ipout(3)=0
C-----INDUT DATA-----------------------------------------------
      lMN=0
      izs(11)=lMN
      lMs=0
      izs(12)=lMs
      read (2,'(i10)') lNs
C-----
      if (idebg.ne.0) then
         write (io1,*)
         write (io1,*) ' lNs=',lNs
      endif
C----------------------
C     lNs ==> izs(13)
C----------------------
      izs(13)=lNs
      ikNs=ifree
      iaNs=ikNs+Ns+1
      ifree=iaNs+lNs
      jaNs=jfree
      jfree=jaNs+lNs
      if (ifree.gt.Mizs.or.jfree.gt.Mdzs) goto 8000
      read (2,'((6i10))') (izs(ikNs+i),i=1,Ns+1)
      read (2,'(3(e10.2,i10))')
     *     (dzs(jaNs+i),izs(iaNs+i),i=1,lNs)
C-----
      if (idebg.ne.0) then
         write (io1,*) ikNs+1,ikNs+Ns+1,' ikNs= '
         write (io1,*) (izs(i),i=ikNs+1,ikNs+Ns+1)
         write (io1,*)
         write (io1,*) iaNs+1,iaNs+lNs,' iaNs= '
         write (io1,*) (izs(i),i=iaNs+1,iaNs+lNs)
         write (io1,*)
         write (io1,*) jaNs+1,jaNs+lNs,' daNs= '
         write (io1,*) (dzs(j),j=jaNs+1,jaNs+lNs)
      endif
C-----Input Mtx, mex, Ax, bx-----------------------------------
      read (2,'(i10)') Mtx
      if (Mtx.ne.0) then
         read (2,'(i10)') mex
         do i=1,Mtx
            read (2,'(6(f10.2))') (Ax(j),j=1+Ns*(i-1),Ns*i)
         enddo
         read (2,'(6(f10.2))') (bx(i),i=1,Mtx)
      endif  
      if (idebg.ne.0) then
         if (Mtx.eq.0) then
            write (io1,*) ' Mtx= ',Mtx
         else
            write (io1,*) ' Mtx= ',Mtx
            write (io1,*) ' mex= ',mex
            do i=1,Mtx
               write (io1,*) ' Ax(',i,')= '       
               write (io1,*) (Ax(j),j=1+Ns*(i-1),Ns*i)
            enddo
            write (io1,*) ' bx= '
            write (io1,*) (bx(i),i=1,Mtx)
         endif
      endif
C-----Generating K blocks--------------------------------------
      Muu=0
      Nuu=0
      Luu=0
      Nbmax=0
      Mbmax=0
      Nx=Ns
      Ny=Ms
      Kineqs=Ms
      Kequas=0
      ilBlk=ifree
      ikineq=ilBlk+Kbl
      iMu=ikineq+Kbl
      iNu=iMu+Kbl
      iLu=iNu+Kbl
      ibegi=iLu+Kbl
      ibegd=ibegi+Kbl
      ibegr=ibegd+Kbl
      ifree=ibegr+Kbl
C-----
      if (idebg.ne.0) then
         write (io1,*)
         write (io1,*) ' ilBlk,ikineq,iMu,iNu,iLu=',
     *                   ilBlk,ikineq,iNu,iNu,iLu
         write (io1,*) ' ibegi,ibegd,ibegr=',
     *                   ibegi,ibegd,ibegr
      endif
      if (ifree.gt.Mizs.or.jfree.gt.Mdzs.or.nfree.gt.Mrzs) 
     *                                                goto 8000
C==============================================================
      Mblk0=Ms
      Nblk0=Ns
      do k=1,Kbl
C--------
         read (2,'(i10)') Mbl
         read (2,'(i10)') Nbl
         if (Nbmax.lt.Nbl) Nbmax=Nbl
         if (Mbmax.lt.Mbl) Mbmax=Mbl
         Nx=Nx+Nbl
         Ny=Ny+Mbl
         KinBlk=Mbl
         KeqBlk=0
         izs(ikineq+k)=KinBlk
         Kineqs=Kineqs+KinBlk
         read (2,'(i10)') lBlk
         izs(ilBlk+k)=lBlk
         izs(ibegi+k)=ifree
         Mu=Mbl
         if (Mu.gt.Muu) Muu=Mu
         izs(iMu+k)=Mu
         Nu=Nbl+Mu+KeqBlk
         Nu2=Nu*Nu
         if (Nu.gt.Nuu) Nuu=Nu
         izs(iNu+k)=Nu
         Lu=Mu*Nu
         if (Lu.gt.Luu) Luu=Lu
         izs(iLu+k)=Lu
         ikBlk=ifree
         iaBlk=ikBlk+(Nbl+1)
         ifree=iaBlk+lBlk
C--------
         izs(ibegd+k)=jfree
         jaBlk=jfree
         jxP=jaBlk+lBlk
         jyP=jxP+Nu
         jlft=jyP+Mu
         jrht=jlft+Nu
         jcP=jrht+Nu
         jdP=jcP+Nu2
         jbP=jdP+Nu
         jaP=jbP+Mu
         jzP=jaP+Mu*Nu
         jfree=jzP+Mu+Nu+Nu
C--------
         izs(ibegr+k)=nfree
         if (idebg.ne.0) then
            write (io1,*) '-----------------------------------'
            write (io1,*) ' Block ',k,' Mbl=',Mbl,' Nbl=',Nbl,
     *                    ' lBlk=',lBlk,' KinBlk=',KinBlk
            write (io1,*) ' Mu=',Mu,' Nu=',Nu,' Lu=',Lu
         endif
C--------
         read (2,'((6i10))') (izs(ikBlk+i),i=1,Nbl+1)
         read (2,'(3(e10.2,i10))')
     *        (dzs(jaBlk+i),izs(iaBlk+i),i=1,lBlk)
         if (idebg.ne.0) then
            write (io1,*)
            write (io1,*) ikBlk+1,ikBlk+Nbl+1,' ikBlk= '
            write (io1,*) (izs(i),i=ikBlk+1,ikBlk+Nbl+1)
            write (io1,*)
            write (io1,*) iaBlk+1,iaBlk+lBlk,' iaBlk= '
            write (io1,*) (izs(i),i=iaBlk+1,iaBlk+lBlk)
            write (io1,*)
            write (io1,*) jaBlk+1,jaBlk+lBlk,' daBlk= '
            write (io1,*) (dzs(j),j=jaBlk+1,jaBlk+lBlk)
         endif
C-----Arrays for Powell----------------------------------------
         do j=1,Nu*Nu
            dzs(jcP+j)=Zero
         enddo
         jj=jcP+1
         do j=1,Nu
            dzs(jj)=epsd
            jj=jj+Nu+1
         enddo
         do j=1,Nu
            dzs(jdP+j)=Zero
            ww=Zero
            if (j.le.Nbl) ww=xl(Nblk0+j) ! Zero
            dzs(jlft+j)=ww
            ww=dinfty
            if (j.le.Nbl) ww=xu(Nblk0+j) ! XbxBl
            dzs(jrht+j)=ww
            dzs(jxP+j)=xl(j) ! Zero
         enddo
         i0=jdP+Nbl
         do i=1,Mu
            dzs(i0+i)=+YbxBl
            dzs(jbP+i)=Zero
            dzs(jyP+i)=Zero
         enddo
C--------
         if (idebg.ne.0) then
            write (io1,*)
            write (io1,*) jxP+1,jxP+Nu,' xBlk= '
            write (io1,*) (dzs(j),j=jxP+1,jxP+Nu)
            write (io1,*)
            write (io1,*) jyP+1,jyP+Mu,' yBlk= '
            write (io1,*) (dzs(j),j=jyP+1,jyP+Mu)
            write (io1,*)
            write (io1,*) jlft+1,jlft+Nu,' xlBlk= '
            write (io1,*) (dzs(j),j=jlft+1,jlft+Nu)
            write (io1,*)
            write (io1,*) jrht+1,jrht+Nu,' xuBlk= '
            write (io1,*) (dzs(j),j=jrht+1,jrht+Nu)
            write (io1,*)
            write (io1,*) jcP+1,jcP+Nu2,' cBlk= '
            write (io1,*) (dzs(j),j=jcP+1,jcP+Nu2)
            write (io1,*)
            write (io1,*) jdP+1,jdP+Nu,' dBlk= '
            write (io1,*) (dzs(j),j=jdP+1,jdP+Nu)
         endif
C-----Matrix for Powell----------------------------------------
         do j=1,Lu
            dzs(jaP+j)=Zero
         enddo
         do j=1,Nbl
            j1=izs(ikBlk+j)+1
            j2=izs(ikBlk+j+1)
            do l=j1,j2
               w=dzs(jaBlk+l)
               i=izs(iaBlk+l)-Mblk0
               jj=jaP+j+Nu*(i-1)
               dzs(jj)=-w
            enddo
         enddo
         jj=jaP+(Nbl-Nu)
         do i=1,Mu
            jj=jj+Nu+1
            dzs(jj)=+One
         enddo
C--------
         if (idebg.ne.0) then
            write (io1,*)
            write (io1,*) jbP+1,jbP+Mu,' b= '
            write (io1,*) (dzs(i),i=jbP+1,jbP+Mu)
            write (io1,*)
            write (io1,*) jaP+1,jaP+Lu,' a= '
            do i=1,Mu
               jj=jaP+Nu*(i-1)
               write (io1,*) (dzs(j),j=jj+1,jj+Nu)
            enddo
            write (io1,*) jzP+1,jzP+Mu+2*Nu,' <= zBlk '
         endif
         Mblk0=Mblk0+Mbl
         Nblk0=Nblk0+Nbl
      enddo                   ! k
C-----
      if (idebg.ne.0) then
         write (io1,*)
         write (io1,*) ilBlk+1,ilBlk+Kbl,' lBlk= ',
     *                 (izs(ilBlk+i),i=1,Kbl)
         write (io1,*) ikineq+1,ikineq+Kbl,' KinBlk= ',
     *                 (izs(ikineq+i),i=1,Kbl)
         write (io1,*) iMu+1,iMu+Kbl,' Mu=',(izs(iMu+i),i=1,Kbl)
         write (io1,*) iNu+1,iNu+Kbl,' Nu=',(izs(iNu+i),i=1,Kbl)
         write (io1,*) iLu+1,iLu+Kbl,' Lu=',(izs(iLu+i),i=1,Kbl)
         write (io1,*) ibegi+1,ibegi+Kbl,' ifree=',
     *                 (izs(ibegi+i),i=1,Kbl)
         write (io1,*) ibegd+1,ibegd+Kbl,' jfree=',
     *                 (izs(ibegd+i),i=1,Kbl)
         write (io1,*) ibegr+1,ibegr+Kbl,' nfree=',
     *                 (izs(ibegr+i),i=1,Kbl)
         write (io1,*) ' Muu,Nuu,Luu=',Muu,Nuu,Luu
      endif
C-----
      irab=ifree
      iwork=Nuu
      ifree=irab+iwork
      jbh=jfree
      jch=jbh+Ny
      jbb=jch+Nx
      jcc=jbb+Ny
      jzz=jcc+Nx
      jrab=jzz+Nx
      jwork=3*Nuu*Nuu/2+10*Nuu+2*(Muu+1)+1
      jfree=jrab+jwork
      jbegin=jfree
      jend=Mdzs
C--------------------------------------------------------------
C     Muu=Mbl ==> izs(14), Nuu=Nbl+Mu ==> izs(15),
C     Luu=Mu*Nu ==> izs(16),
C     ifree(Kbl) ==> izs(17), jfree(Kbl) ==> izs(18),
C     jend => izs(19), nfree => izs(20)
C-----
C     ifree(Kbl)<=Mizs, jfree(Kbl)<=Mdzs, nfree<=Mrzs
C--------------------------------------------------------------
      izs(4)=Mbmax
      izs(5)=Nbmax
      izs(6)=it
      izs(8)=Nx
      izs(9)=Ny
      izs(14)=Muu
      izs(15)=Nuu
      izs(16)=Luu
      izs(17)=ifree
      izs(18)=jbegin
      izs(19)=jend
      izs(20)=nfree
      if (ifree.gt.Mizs.or.jfree.gt.Mdzs.or.nfree.gt.Mrzs) goto 8000
C-----
      if (idebg.ne.0) then
         write (io1,*)
         write (io1,*) ' jbh,jch,jbb,jcc,jzz=',jbh,jch,jbb,jcc,jzz
         write (io1,*) ' irab,iwork,ifree,jrab,jwork,jfree,nfree=',
     *                   irab,iwork,ifree,jrab,jwork,jfree,nfree
      endif
C-----
      do i=1,Ny
         dzs(jbh+i)=BB(i)
      enddo
      do j=1,Nx
         dzs(jch+j)=CC(j)
      enddo
C=====PREPARATION TO PDLEV=====================================
      close (2)
C-----
      ifail=0
      do i=1,niwar
         iwar(i)=0
      enddo
      do i=1,nwar
         war(i)=Zero
      enddo
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      call pdlev (Ns,Mtx,mex,xl,xu,Ax,bx,xin,xout,izs,rzs,
     *            dzs,fun,ipin,rpin,ipout,rpout,war,iwar)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C=====ANSWERS==================================================
      Fopt=Zero
      do j=1,Nx
         ww=dzs(jzz+j)
         Fopt=Fopt+CC(j)*ww
         xout(j)=ww
      enddo
C-----
      do i=1,Ny
         Res(i)=BB(i)
      enddo
      do j=1,Ns
         xx=xout(j)
         if (xx.ne.Zero) then
            j1=izs(ikNs+j)+1
            j2=izs(ikNs+j+1)
            if (j1.le.j2) then
               do l=j1,j2
                  i=izs(iaNs+l)
                  ww=dzs(jaNs+l)
                  if (ww.ne.Zero) Res(i)=Res(i)-ww*xx
               enddo
            endif
         endif
      enddo
C-----
      Nblk0=Ns
      Mblk0=Ms
      do k=1,Kbl
         Mu=izs(iMu+k)
         Nu=izs(iNu+k)
         lBlk=izs(ilBlk+k)
         Mbl=Mu
         Nbl=Nu-Mbl
         ifree=izs(ibegi+k)
         ikBlk=ifree
         iaBlk=ikBlk+Nbl+1
         jfree=izs(ibegd+k)
         jaBlk=jfree
         do j=1,Nbl
            xx=xout(Nblk0+j)
            if (xx.ne.Zero) then
               j1=izs(ikBlk+j)+1
               j2=izs(ikBlk+j+1)
               if (j1.le.j2) then
                  do l=j1,j2
                     i=izs(iaBlk+l)
                     ww=dzs(jaBlk+l)
                     if (ww.ne.Zero) Res(i)=Res(i)-ww*xx
                  enddo
               endif
            endif
         enddo
         Nblk0=Nblk0+Nbl
         Mblk0=Mblk0+Mbl
      enddo
      ErrRes=Zero
      do i=1,Ny
         w=Res(i)/(One+dabs(BB(i)))
         ww=w
         if (w.gt.Zero) ww=Zero
         if (ww.gt.ErrRes) ErrRes=ww
      enddo
C-----
      write (io1,*) ' xout='
      write (io1,'(5(e15.8))') (xout(j),j=1,Nx)
      write (io1,*) ' Res='
      write (io1,'(5(e15.8))') (Res(i),i=1,Ny)
C-----
      jo1=ipout(1)
      jo2=ipout(2)
      itr=ipout(3)
      ndom=ipout(4)
      icodi=ipout(5)
      Mxbndl=ipout(6)
      Nmbndl=ipout(7)
      ncrit=ipout(8)
      isumor=ipout(9)
      isumpl=ipout(10)
      isumpq=ipout(11)
      isumpc=ipout(12)
C-----
      Gap=rpout(1)
      Fmodx=-rpout(2)
      Fmody=rpout(3)
      Relacc=rpout(4)
      Fmax=rpout(5)
      Fmin=rpout(6)
      Diam=Fmax-Fmin
      Fxy=rpout(7)
      Avit=rpout(8)
C=====Termination==============================================
      txt='*** Termination****************'
      call msg (ipin,-1,0,txt,0,Zero)
      txt='--- Reason for termination:'
      call msg (ipin,-1,0,txt,0,Zero)
      if (jo1.eq.-2.or.jo1.eq.5) then
         txt='    Not enough real memory'
      endif
      if (jo1.eq.-1) then
         txt='    Not enough integer memory'
      endif
      if (jo1.eq.-11) then
         txt='    Bundle overflow'
      endif
      if (jo1.eq.-10) then
         txt='    Too many iterations'
      endif
      if (jo1.eq.0) then
         txt='    Normal end'
      endif
      if (jo1.eq.-6) then
         txt='    Shrinking bundle leads to loop'
      endif
      if (jo1.le.0.or.jo1.eq.5) then
         call msg (ipin,-1,0,txt,0,Zero)
      else
         txt='    Difficulty # '
         call msg (ipin,0,0,txt,io1,Zero)
      endif
      txt='--- Type of result:'
      call msg (ipin,-1,0,txt,0,Zero)
      if (jo2.eq.-2) then
         txt='    Nothing found'
         call msg (ipin,-1,0,txt,0,Zero)
      endif
      if (jo2.eq.-1) then
         txt='    Unfeasibility found'
         call msg (ipin,-1,0,txt,0,Zero)
      endif
      if (jo2.eq.0) then
         txt='    Feasible solution found'
         call msg (ipin,-1,0,txt,0,Zero)
      endif
      if (jo2.eq.1) then
         txt='    Required accuracy ensured'
         call msg (ipin,-1,0,txt,0,Zero)
      endif
      if (jo2.eq.2) then
         txt='    Auxilyary results'
         call msg (ipin,-1,0,txt,0,Zero)
      endif
      if (jo2.ge.0) then
         txt='    Fmax            <= '
         call msg (ipin,1,0,txt,0,Fmax)
         txt='    Fxy             <= '
         call msg (Ipin,1,0,txt,0,Fxy)
         txt='    Fmin            <= '
         call msg (ipin,1,0,txt,0,Fmin)
         txt='    - Fmodx         <= '
         call msg (ipin,1,0,txt,0,-Fmodx)
         txt='    Fmody           <= '
         call msg (ipin,1,0,txt,0,Fmody)
         txt='    Absolute error  <= '
         call msg (ipin,1,0,txt,0,dabs(Gap))
         txt='    Relative error  <= '
         call msg (ipin,1,0,txt,0,Relacc)
         txt='--- Rel. Residual error'
         call msg (ipin,1,0,txt,0,ErrRes)
         txt='--- Iterations: '
         call msg (ipin,0,0,txt,itr,Zero)
         txt='--- # in dom  : '
         call msg (ipin,0,0,txt,ndom,Zero)
      endif
      if (itr.ge.1) then
         txt='--- Bundle cardinality '
         call msg (ipin,-1,0,txt,0,Zero)
         txt='    maximum: '
         call msg (ipin,0,0,txt,Mxbndl,Zero)
         txt='    average: '
         call msg (ipin,1,0,txt,0,Avit)
         txt='--- # of bundle shrinkings '
         call msg (ipin,0,0,txt,Nmbndl,Zero)
         txt='--- # of auxiliary problems : '
         call msg (ipin,0,0,txt,ncrit,Zero)
      endif
      if (isumor.ne.0) then
         txt=' # of Oracle iterations '
         call msg (ipin,0,0,txt,isumor,Zero)
      endif
      if (isumpl.ne.0) then
         txt=' # of Powell iterations (LP)'
         call msg (ipin,0,0,txt,isumpl,Zero)
      endif
      if (isumpq.ne.0) then
         txt=' # of Powell iterations (QP)'
         call msg (ipin,0,0,txt,isumpq,Zero)
      endif
      if (isumpc.ne.0) then
         txt=' # of Powell iterations (PC)'
         call msg (ipin,0,0,txt,isumpc,Zero)
      endif
C==============================================================
      close (io1)
      goto 9000
C=====IF THERE WERE ERRORS=====================================
 8000 continue
      write (*,*)
      write (*,*) ' ifree=',ifree,' mizs=',Mizs
      write (*,*) ' jfree=',jfree,' mdzs=',Mdzs
      write (*,*) ' nfree=',nfree,' mrzs=',Mrzs
      write (*,*) ' jrab=',jrab,' jwork=',jwork
      write (*,*)
      stop 8000
C-----
 9000 continue
      end
